/*////////////////////////////////////////////////////////////////////////
Copyright (c) 1999 Electrotechnical Laboratry (ETL), AIST, MITI

Permission to use, copy, and distribute this material for any
purpose and without fee is hereby granted, provided that the above
copyright notice and this permission notice appear in all copies, and
that the name of ETL not be used in advertising or publicity pertaining
to this material without the specific, prior written permission of an
authorized representative of ETL.
ETL MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR SUITABILITY OF THIS
MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS", WITHOUT ANY EXPRESS
OR IMPLIED WARRANTIES.
/////////////////////////////////////////////////////////////////////////
Content-Type:	program/C; charset=US-ASCII
Program:	forkspawn.c
Author:		Yutaka Sato <ysato@etl.go.jp>
Description:
History:
	990205	extracted from misc.c
//////////////////////////////////////////////////////////////////////#*/
#include <stdio.h>

int MyPID;
Getpid(){
	if( MyPID == 0 )
		MyPID = getpid();
	return MyPID;
}
Fork(what)
	char *what;
{	register int pid;

	endhostent();
	MyPID = 0;
	pid = fork();
	if( pid == 0 ){
		MyPID = getpid();
		syslog_ERROR("-- Fork(%s): %d -> %d\n",what,getppid(),MyPID);
	}
	return pid;
}
extern int SPAWN_P_NOWAIT;
Spawnvp(what,path,av)
	char *what,*path,*av[];
{	int pid;

	MyPID = 0;
	pid = spawnvp(SPAWN_P_NOWAIT,path,av);
	return pid;
}

Exit(code,fmt,a,b,c,d,e,f,g)
	char *fmt,*a,*b,*c,*d,*e,*f,*g;
{	char msg[2048];

	if( code != 0 ){
		sprintf(msg,"Exit (%d) ",code);
		sprintf(msg+strlen(msg),fmt,a,b,c,d,e,f,g);
		syslog_ERROR("%s",msg);
	}
	Finish(code);
}

extern int WAIT_WNOHANG;
NoHangWait()
{
	return wait3(NULL,WAIT_WNOHANG,NULL);
}

extern int errno;
extern char *getusernames();
Execvp(where,path,av)
	char *where,*path,*av[];
{	int rcode;
	char pwd[1024];
	char names[1024];
	char *nav[2];

	BeforeExec();
	endhostent();
	if( av[0] == NULL ){
		nav[0] = nav[1] = NULL;
		av = nav;
	}
	rcode = execvp(path,av);

	fprintf(stderr,"%s: Could not execute COMMAND: %s\n",where,path);
	fprintf(stderr," with the OWNER uid/gid: %s\n",getusernames(names));
	fprintf(stderr," at the DIR: %s\n",getcwd(pwd,sizeof(pwd)));
	fprintf(stderr,"You should check that you can execute the COMMAND\n");
	fprintf(stderr," at the DIR with the access right of the OWNER.\n");
	perror("proc_title_init");
	Exit(-1,"%s(%s) failed(%d) errno=%d\n",where,path,rcode,errno);
}
Kill(pid,sig)
{
	syslog_ERROR("Kill(%d,%d)\n",pid,sig);
	if( pid == 0 || pid == 1 || pid == -1 ){
		syslog_ERROR("Error: tried to Kill %d X-<\n",pid);
		return -1;
	}
	return kill(pid,sig);
}
Killpg(pgrp,sig)
{
	syslog_ERROR("Killpg(%d,%d)\n",pgrp,sig);
	if( pgrp == 0 || pgrp == 1 ){
		syslog_ERROR("Error: tried to Killpg %d X-<\n",pgrp);
		return -1;
	}
	return killpg(pgrp,sig);
}
